# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
return l_command_table();
break;
case 2:
	return l_request();
break;
case 3:
return l_unimplemented();
break;
case 4:
	return l_end();
break;
case 5:
	;
break;
case 6:
return l_quoted_string();
break;
case 7:
	return l_string();
break;
case 8:
	;
break;
case 9:
	return (*yytext);
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
/*
 * User-subroutines section.
 *
 * Have to put all this stuff here so that the include file
 * from YACC output can be included, since LEX doesn't allow
 * an include file before the code it generates for the above
 * rules.
 *
 * Copyright 1987 by MIT Student Information Processing Board.
 *
 * For copyright info, see mit-sipb-copyright.h.
 */
#include <string.h>
#include "ct.h"
#include "mit-sipb-copyright.h"

extern char *last_token, *ds();

static l_command_table()
{
     last_token = "command_table";
     return COMMAND_TABLE;
}

static l_request()
{
     last_token = "request";
     return REQUEST;
}

static l_unimplemented()
{
     last_token = "unimplemented";
     return UNIMPLEMENTED;
}

static l_end()
{
     last_token = "end";
     return END;
}

static l_quoted_string()
{
     register char *p;
     yylval.dynstr = ds(yytext+1);
     if (p=rindex(yylval.dynstr, '"'))
	  *p='\0';
     last_token = ds(yylval.dynstr);
     return STRING;
}

static l_string()
{
     yylval.dynstr = ds(yytext);
     last_token = ds(yylval.dynstr);
     return STRING;
}
int yyvstop[] = {
0,

7,
0,

7,
0,

9,
0,

5,
9,
0,

5,
0,

9,
0,

9,
0,

7,
9,
0,

7,
9,
0,

7,
9,
0,

7,
9,
0,

7,
9,
0,

6,
0,

8,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

4,
7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

2,
7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

7,
0,

1,
7,
0,

3,
7,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	6,13,	0,0,	7,15,	
0,0,	0,0,	1,4,	1,5,	
0,0,	6,13,	6,13,	7,15,	
7,16,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,6,	
1,7,	2,7,	6,14,	0,0,	
7,15,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,8,	0,0,	0,0,	
6,13,	0,0,	7,15,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
1,9,	2,9,	1,10,	2,10,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	0,0,	1,11,	
2,11,	0,0,	1,12,	2,12,	
0,0,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	9,18,	
10,19,	11,20,	12,21,	8,17,	
18,22,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	8,17,	
8,17,	8,17,	8,17,	19,23,	
20,24,	21,25,	22,26,	24,27,	
25,28,	26,29,	27,30,	28,31,	
29,32,	30,33,	31,34,	32,35,	
33,36,	34,37,	35,38,	37,39,	
38,40,	39,41,	40,42,	41,43,	
42,44,	43,45,	44,46,	45,47,	
46,48,	47,49,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+-2,	yysvec+1,	yyvstop+3,
yycrank+0,	0,		yyvstop+5,
yycrank+0,	0,		yyvstop+7,
yycrank+0,	0,		yyvstop+10,
yycrank+-4,	0,		yyvstop+12,
yycrank+-6,	0,		yyvstop+14,
yycrank+56,	0,		yyvstop+16,
yycrank+36,	yysvec+8,	yyvstop+19,
yycrank+38,	yysvec+8,	yyvstop+22,
yycrank+48,	yysvec+8,	yyvstop+25,
yycrank+40,	yysvec+8,	yyvstop+28,
yycrank+0,	yysvec+6,	0,	
yycrank+0,	0,		yyvstop+31,
yycrank+0,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+33,
yycrank+0,	yysvec+8,	yyvstop+35,
yycrank+43,	yysvec+8,	yyvstop+37,
yycrank+79,	yysvec+8,	yyvstop+39,
yycrank+67,	yysvec+8,	yyvstop+41,
yycrank+76,	yysvec+8,	yyvstop+43,
yycrank+73,	yysvec+8,	yyvstop+45,
yycrank+0,	yysvec+8,	yyvstop+47,
yycrank+66,	yysvec+8,	yyvstop+50,
yycrank+75,	yysvec+8,	yyvstop+52,
yycrank+88,	yysvec+8,	yyvstop+54,
yycrank+85,	yysvec+8,	yyvstop+56,
yycrank+75,	yysvec+8,	yyvstop+58,
yycrank+78,	yysvec+8,	yyvstop+60,
yycrank+74,	yysvec+8,	yyvstop+62,
yycrank+82,	yysvec+8,	yyvstop+64,
yycrank+91,	yysvec+8,	yyvstop+66,
yycrank+76,	yysvec+8,	yyvstop+68,
yycrank+92,	yysvec+8,	yyvstop+70,
yycrank+99,	yysvec+8,	yyvstop+72,
yycrank+0,	yysvec+8,	yyvstop+74,
yycrank+86,	yysvec+8,	yyvstop+77,
yycrank+80,	yysvec+8,	yyvstop+79,
yycrank+96,	yysvec+8,	yyvstop+81,
yycrank+101,	yysvec+8,	yyvstop+83,
yycrank+89,	yysvec+8,	yyvstop+85,
yycrank+102,	yysvec+8,	yyvstop+87,
yycrank+85,	yysvec+8,	yyvstop+89,
yycrank+94,	yysvec+8,	yyvstop+91,
yycrank+102,	yysvec+8,	yyvstop+93,
yycrank+103,	yysvec+8,	yyvstop+95,
yycrank+105,	yysvec+8,	yyvstop+97,
yycrank+0,	yysvec+8,	yyvstop+99,
yycrank+0,	yysvec+8,	yyvstop+102,
0,	0,	0};
struct yywork *yytop = yycrank+205;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,01  ,01  ,01  ,01  ,'0' ,
01  ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
